package org.agt.module.license.service.alert;

import jakarta.annotation.Resource;
import org.agt.framework.common.pojo.PageResult;
import org.agt.framework.common.util.object.BeanUtils;
import org.agt.module.license.controller.admin.alert.vo.AlertPageReqVO;
import org.agt.module.license.controller.admin.alert.vo.AlertSaveReqVO;
import org.agt.module.license.dal.dataobject.alert.AlertDO;
import org.agt.module.license.dal.mysql.alert.AlertMapper;
import org.agt.module.system.api.mail.MailTemplateApi;
import org.agt.module.system.api.mail.dto.MailTemplateSaveReqDTO;
import org.agt.module.system.api.notify.NotifyTemplateApi;
import org.agt.module.system.api.notify.dto.NotifyTemplateSaveReqDTO;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import static org.agt.framework.common.exception.util.ServiceExceptionUtil.exception;
import static org.agt.module.license.enums.ErrorCodeConstants.ALERT_NOT_EXISTS;

/**
 * 告警 Service 实现类
 *
 * @author super
 */
@Service
@Validated
public class AlertServiceImpl implements AlertService {

    @Resource
    private AlertMapper alertMapper;

    @Resource
    private MailTemplateApi mailTemplateApi;

    @Resource
    private NotifyTemplateApi notifyTemplateApi;

    @Override
    public Long createAlert(AlertSaveReqVO createReqVO) {
        // 插入
        AlertDO alert = BeanUtils.toBean(createReqVO, AlertDO.class);
        alertMapper.insert(alert);

        mailTemplateApi.updateMailTemplate(new MailTemplateSaveReqDTO().setId(18L).setContent(createReqVO.getContent()));
        notifyTemplateApi.updateNotifyTemplate(new NotifyTemplateSaveReqDTO().setId(2L).setContent(createReqVO.getContent()));
        // 返回
        return alert.getId();
    }

    @Override
    public void updateAlert(AlertSaveReqVO updateReqVO) {
        // 校验存在
        validateAlertExists(updateReqVO.getId());
        // 更新
        AlertDO updateObj = BeanUtils.toBean(updateReqVO, AlertDO.class);
        alertMapper.updateById(updateObj);

        mailTemplateApi.updateMailTemplate(new MailTemplateSaveReqDTO().setId(18L).setContent(updateReqVO.getContent()));
        notifyTemplateApi.updateNotifyTemplate(new NotifyTemplateSaveReqDTO().setId(2L).setContent(updateReqVO.getContent()));
    }

    @Override
    public void deleteAlert(Long id) {
        // 校验存在
        validateAlertExists(id);
        // 删除
        alertMapper.deleteById(id);
    }

    private void validateAlertExists(Long id) {
        if (alertMapper.selectById(id) == null) {
            throw exception(ALERT_NOT_EXISTS);
        }
    }

    @Override
    public AlertDO getAlert(Long id) {
        return alertMapper.selectById(id);
    }

    @Override
    public PageResult<AlertDO> getAlertPage(AlertPageReqVO pageReqVO) {
        return alertMapper.selectPage(pageReqVO);
    }

}